//////////////////////////////////////////////////////////////////////
//  Copyright:
//        Hans Jelders RWS / CDFA., (c) 2013. All rights reserved.
//  Contents:
//        This is a standard win32 exe.
//////////////////////////////////////////////////////////////////////
//
// nog te doen:
// helpfile zit vast

#PRAGMA LIBRARY("ASCOM10.LIB")
#PRAGMA LIBRARY("dclipx.lib")

#INCLUDE "appevent.ch"
#INCLUDE "Common.ch"
#INCLUDE "dcdialog.ch"
#include "dcapp.ch"
#include "gra.ch"

#define xlWorkbookNormal -4143

#define aSap     aLocals[ 1]
#define aFlow    aLocals[ 2]
#define aVerdeel aLocals[ 3]
#define cInFile  aLocals[ 4]
#define cOutFile aLocals[ 5]
#define aTabs    aLocals[ 6]
#define lExcelOn aLocals[ 7]
#define nNietMee aLocals[ 8]
#define aKop     aLocals[ 9]

#define A_FLOWITEM  12        //aSap
#define A_DGNTOT     9        //aSap
#define A_IKG       15        //aSap
#define V_LEIDER     1        //aVerdeel
#define V_IKG        2        //aVerdeel
#define F_FLOWITEM   1        //aFlow
#define F_TABBLAD    2        //aFlow

PROCEDURE AppSys
   SET CHARSET TO ANSI
RETURN

//PROCEDURE dbesys()
//RETURN

PROCEDURE Main
**************
LOCAL Getlist:={}, aLocals[9], lOk:=.F., i, nElap, cPad:="" //, oError

cInFile :=PadR(Strtran(appname(.T.),appname(),'')+'zwfb 27-08-2013.XLS',90,' ')
cPad:= DC_PATH(cInFile)
//cInFile :=Space(90)
lExcelOn:=.T.
nNietMee:=14
aKop    :=Array(2)                                         //2 pagina koppen

////kolom N (subflows) in sheet
aFlow:={{"Bewerken masterdata crediteur"           ,"Wim"}   ,;
        {"LIGHT: Grootboeknummer invullen"         ,"Wim"}   ,;
        {"Subflow Light Fin Admin: afhandelen doc" ,"Wim"}   ,;
        {"Subflow Light Fin Admin: registreer doc1","Wim"}   ,;
        {"Subflow Light Fin Admin: registreer doc2","Wim"}   ,;
        {"Subflow Light Inkoop: Goedkeuring Light" ,"Inkoop"},;
        {"Subflow Light Inkoop: Goedkeuring PV"    ,"Verdeel"}   ,;
        {"Subflow Light PAV individueel"           ,"Verdeel"}  ,;
        {"Subflow Light PAV: accordeer doc RWS"    ,"Verdeel"}   ,;
        {"Subflow Light Inkoop: controleer doc"    ,"Wim"}   ,;
        {"Subflow: Afhandeling BTW specialist"     ,"Wim"}   ,;
        {"Subflow: Behandelen door Inkoop"         ,"Inkoop"},;
        {"Subflow: Fin Adm: afhandelen"            ,"Wim"}   ,;
        {"Subflow: Fin Adm: afhandelen creditnota" ,"Inkoop"},;
        {"Subflow: Fin Adm: boek doc"              ,"Wim"}   ,;
        {"Subflow: Inkopers aanvr credit nota"     ,"Inkoop"},;
        {"Subflow: Inkopers contr P blok"          ,"Inkoop"},;
        {"Subflow: keuze ind PV'er Q blok"         ,"Verdeel"}   ,;
        {"Subflow: PV contr Q-blok (groep)"        ,"Verdeel"}   ,;
        {"Subflow: PV contr Q-blok (indiv.)"       ,"Verdeel"}}

aVerdeel:={{"Aicha"     ,{10,13,14}},;
           {"Bernadette",{5,9,11,12,29}},;
           {"Maurice"   ,{6,7,26,27}},;
           {"Susanne"   ,{8,20,28}},;
           {"TiesHarrie",{15,17,18,19,30,31}}}

aTabs:={'Inkoop','Wim','Aicha','Bernadette','Maurice','Susanne','TiesHarrie','','Niet verwerkt'}

//BEGIN SEQUENCE
@1, 5 DCSAY 'In te lezen ZWFB bestand uit SAP:' ;
      GET cInFile GETPOS 2,5 GETSIZE 75,1 PICTURE "@K";
      POPUP {|c|DC_PopFile(c,,"*.xls")}POPSTYLE DCGUI_POPUPSTYLE_IMBEDDED;
      SAYOPTION XBPSTATIC_TEXT_VCENTER
@3.5, 5 DCSAY 'Alleen workflows met dagen tot betaling korter dan (dgn):';
      GET nNietMee GETPOS 3.5,45 GETSIZE 5,1 PICTURE '999';
      SAYOPTION XBPSTATIC_TEXT_VCENTER
@5, 5 DCCHECKBOX lExcelOn PROMPT 'Laat Excel zien'
@7, 5 DCPUSHBUTTON CAPTION "Afbreken"  SIZE 10,1;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}
@7,16 DCPUSHBUTTON CAPTION "Verwerken" SIZE 10,1;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} WHEN {||!Empty(cInFile)}
@7,48 DCPUSHBUTTON CAPTION 'Flow' SIZE 10,1 ACTION {||MyEdit(cPad+"flow")}
@7,60 DCPUSHBUTTON CAPTION 'IKG'  SIZE 10,1 ACTION {||MyEdit(cPad+"ikg")}
@7,72 DCPUSHBUTTON CAPTION 'Help' SIZE 10,1 ACTION {||DisplayHelp()}

DCREAD GUI FIT TITLE 'Inlezen SAP/ZWFB bestand ' TO lOk

IF lOk .AND.!File(cInFile)
   DC_WinAlert("Bestand: "+cInFile+" bestaat niet!")
   lOk:=.F.
ENDIF

IF lOk
   nElap:=Seconds()
   aTabs[8]:='> '+AllTrim(Str(nNietMee))+' dagen'
   cOutFile:=StrTran(Lower(cInFile),".xls"," new.xls")     //uitvoerbestandsnaam
   aSap:=DC_Excel2Array(cInFile)                           //vul array met excelgegevens
   aSap[3,3]:=aSap[3,1]                                    //datum op regel 3 verplaatsen van kolom 1 naar kolom 3
   FOR i:=1 TO Len(aSap)                                   //doorloop array
      ARemove(aSap[i],1,2)                                 //en verwijder 1e twee kolommen in de hele tabel
   NEXT i
   aKop[1]:=aSap[3]                                        //bewaar kopregels uit aSap
   aKop[2]:=aSap[5]
   ARemove(aSap,1,6)                                       //weg met 1e 6 regels (alleen data over)
   ARemove(aSap,Len(aSap)-1,2)                             //laatste 2 regels doen ook niet mee
   lOk:=SchrijfExcel(aLocals)                              //ga excelsheet maken
   nElap:=Seconds()-nElap
ENDIF
DC_WinAlert(IIF(lOk,'Nieuw gemaakt Excel bestand is: '+;
                        Chr(13)+Chr(10)+Chr(10)+Trim(cOutFile)+;
                        Chr(13)+Chr(10)+Chr(10)+'In '+AllTrim(Str(nElap))+' seconden voor u gedaan!',;
                    'Programma is afgebroken'))
/*
RECOVER USING oError
IF valtype(oApp)='O'
   IF valtype(oSheet)='O'
      oSheet:=NIL
   ENDIF
   oApp:Quit()
   oApp:Destroy()
ENDIF
DC_WinAlert("Er is een fout opgetreden!")
END SEQUENCE
*/
RETURN

FUNCTION SchrijfExcel(aLocals)
******************************
LOCAL oApp, i, aHulp:={}, aTabNaam, cTabNaam

oApp:=CreateObject("Excel.Application")                    //Start Excel
IF NIL==oApp                                               // Excel.Application could not be created.
   DC_WinAlert("Excel is niet geinstalleerd!")
   RETURN .F.
ENDIF
oApp:visible:=IIF(lExcelOn,.T.,.F.)                        //maak excel zichtbaar
oApp:Application:DisplayAlerts:=.F.                        //geen excel pop up messages
oApp:Application:Workbooks:new()                           //Create a workbook from scratch
oApp:Application:Workbooks:add()                           //voeg een workbook toe

FOR i:=4 TO Len(aTabs)                                     //excel opent standaard 3 tabs dus start bij 4
   oApp:Application:Worksheets:add()                       //maak er genoeg bij
NEXT i

FOR i:=1 TO Len(aTabs)                                     //hernoem naam tabladen
   oApp:Application:Worksheets(i):activate()               //maak i sheet aktief
   oApp:Application:Worksheets(i):name:=aTabs[i]           //Rename i sheet
NEXT i

FOR i:=1 TO Len(aSap)                                      //doorloop alle regels
   IF aSap[i,A_DGNTOT]!=NIL .AND. aSap[i,A_DGNTOT]>nNietMee //valt binnen #dagen
      AAdd(aHulp,aSap[i])                                  //later dan xx dagen
      ARemove(aSap,i)                                      //verwijder regel
      i:=i-1
   ENDIF
NEXT i
ASort(aHulp,1,,{|aX,aY| aX[A_DGNTOT] < aY[A_DGNTOT] } )    //sorteer
MaakXLSTab(oApp,aHulp,aTabs[8],aLocals)                    //maak het xls-blad

aTabNaam:={}                                               //init tabbladnaam
FOR i:=1 TO Len(aFlow)                                     //maak tabs voor inkoop en wim
   IF !aFlow[i,F_TABBLAD]$aTabNaam                         //staat tabnaam niet al in tabel
      AAdd(aTabNaam,aFlow[i,F_TABBLAD])                    //voeg tabnaam toe in tabel
      cTabNaam:=aFlow[i,F_TABBLAD]
      IF !cTabNaam="Verdeel"
         aHulp:=CreateTab1(cTabNaam,aLocals)               //vullen met juiste gegevens
         MaakXLSTab(oApp,aHulp,cTabNaam,aLocals)
      ENDIF
   ENDIF
NEXT i

aTabNaam:={}                                               //init tabbladnaam
FOR i:=1 TO Len(aVerdeel)                                  //maak tabs voor teamleiders
   IF !aVerdeel[i,V_LEIDER]$aTabNaam                       //staat tabnaam niet al in tabel
      AAdd(aTabNaam,aVerdeel[i,V_LEIDER])                  //voeg tabnaam toe in tabel
      cTabNaam:=aVerdeel[i,V_LEIDER]
      aHulp:=VerdeelIKG(cTabNaam,aLocals)
      MaakXLSTab(oApp,aHulp,cTabNaam,aLocals)
   ENDIF
NEXT i

IF !Len(aSap)=0
   MaakXLSTab(oApp,aSap,aTabs[Len(aTabs)],aLocals)
ENDIF

oApp:application:workbooks(1):SaveAs(cOutFile,xlWorkbookNormal) //bewaar sheet op schijf
oApp:quit()                                                //sluit excel
oApp:destroy()                                             //object weg
RETURN .T.

FUNCTION CreateTab1(cNaam,aLocals)
*********************************
*selecteren wf-items voor cNaam in hulptabel
LOCAL i, j, aHulp:={}, cZoek

FOR i:=1 TO Len(aFlow)                                     //doorloop alle flowitems
   IF aFlow[i,F_TABBLAD]=cNaam                             //alleen van cnaam (inkoop, wim, over)
      cZoek:=Trim(aFlow[i,F_FLOWITEM])                     //bewaar bewuste flow
      FOR j:=1 TO Len(aSap)                                //doorloop alle regels
         IF aSap[j,A_FLOWITEM]!=NIL .AND. Trim(aSap[j,A_FLOWITEM])==cZoek  //alleen betreffende flow
            AAdd(aHulp,aSap[j])                            //zet regel in ahulp
            ARemove(aSap,j)
            j:=j-1
         ENDIF
      NEXT j
   ENDIF
NEXT i
ASort(aHulp,1,,{|aX,aY| aX[A_DGNTOT] < aY[A_DGNTOT] } )    //sorteer op 2 kopregels na
RETURN aHulp

FUNCTION VerdeelIKG(cNaam,aLocals)
**********************************
*selecteren wf-items voor cNaam in hulptabel
LOCAL i, j, aHulp:={}, aZoek:=NIL, cZoek:=""

SET EXACT ON
FOR i:=1 TO Len(aVerdeel)                                  //doorloop alle teamleiders
   cZoek:=aVerdeel[i,V_LEIDER]
   IF cZoek=cNaam                                          //alleen van teamleider
      aZoek:=aVerdeel[i,V_IKG]                             //bewaar bewuste ikg
      FOR j:=1 TO Len(aSap)                                //doorloop alle regels
         IF aSap[j,A_IKG]$aZoek
            AAdd(aHulp,aSap[j])                            //zet regel in ahulp
            ARemove(aSap,j)
            j:=j-1
         ENDIF
      NEXT j
   ENDIF
NEXT i
SET EXACT OFF
****sorteren op inkoopgroep en dan op dgntot
ASort(aHulp,1,,{|aX,aY| Str(aX[A_IKG],3)+Str(aX[A_DGNTOT],4);
                      < Str(aY[A_IKG],3)+Str(aY[A_DGNTOT],4)})
RETURN aHulp

FUNCTION MaakXLSTab(oApp,aHulp,cTabNaam,aLocals)
************************************************
LOCAL oSheet

AAdd(aHulp,{})
AAdd(aHulp,{})
AIns(aHulp,1,aKop[2])                                      //kopgegevens toevoegen
AIns(ahulp,1,aKop[1])
oApp:Application:Worksheets(cTabNaam):activate()           //maak juiste sheet aktief
oSheet:=oApp:Worksheets(cTabNaam):cells                    //versnel door object met cellen
oSheet:range("A1","X"+AllTrim(Str(Len(aHulp)))):Value:=aHulp //schrijven gegevens in tab
MaakMinRood(oSheet,aHulp)
RETURN NIL

FUNCTION Displayhelp()
**********************
*Laat help-scherm zien

LOCAL GetList:={}, GetOptions, cMemo, oRTF:=NIL

cMemo :=MemoRead('help.rtf')

@ 0,0 DCRTF OBJECT oRTF SIZE 100,30 VAR cMemo ;
      SCROLLBARS XBP_SCROLLBAR_HORIZ + XBP_SCROLLBAR_VERT ;
      APPEARANCE XBP_APPEARANCE_3D ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCGETOPTIONS RESIZE
DCREAD GUI FIT TITLE "Helpinformatie" OPTIONS GetOptions
RETURN NIL

FUNCTION MaakMinRood(oSheet,aHulp)
*********************************
//dit gaat per regel; beter met een range
LOCAL i

FOR i:=3 TO Len(aHulp)
   IF aHulp[i,9]<0
      oSheet:range(CelId('I',i)+':'+CelId('J',i)):Font:ColorIndex:=3
      oSheet:range(CelId('I',i)+':'+CelId('J',i)):Font:Bold:=.T.
   ENDIF
NEXT
RETURN NIL

FUNCTION CelId(cId,nRow)
************************
RETURN AllTrim(cId)+AllTrim(Str(nRow))

FUNCTION MyEdit(cBestand)
*************************
LOCAL oObj:=NIL
USE &cBestand NEW
oObj:=DC_GUIGRUMPBROW ("ADCO")
close database
RETURN NIL